#!/usr/bin/env python
#Author: Mark Feineigle
#Create Date: 2018/04/16
#Last Modify: 2018/04/16
# deeper learning insights machine learning page 192

import matplotlib.pyplot as plt
import numpy as np
import pandas as pd

# Load the data
df = pd.read_csv('/home/egg/projects/deeper_insights_machine_learning/wdbc.data',
header=None)
# Next, we assign the 30 features to a NumPy array X. Using LabelEncoder, we
# transform the class labels from their original string representation (M and
# B) into integers:
from sklearn.preprocessing import LabelEncoder
X = df.loc[:, 2:].values
y = df.loc[:, 1].values
le = LabelEncoder()
y = le.fit_transform(y)
print le.transform(['M', 'B'])

# Split
from sklearn.cross_validation import train_test_split
X_train, X_test, y_train, y_test = train_test_split(X, y, 
                                                    test_size=0.20,
                                                    random_state=1)
## Create the pipeline
from sklearn.grid_search import GridSearchCV
from sklearn.pipeline import Pipeline
from sklearn.preprocessing import StandardScaler
from sklearn.svm import SVC
pipe_svc = Pipeline([('scl', StandardScaler()),
                     ('clf', SVC(random_state=1))])

# Confusion matrix
from sklearn.metrics import confusion_matrix
pipe_svc.fit(X_train, y_train)
y_pred = pipe_svc.predict(X_test)
confmat = confusion_matrix(y_true=y_test, y_pred=y_pred)
print(confmat)
# [[71 1]
# [ 2 40]]

fig, ax = plt.subplots(figsize=(2.5, 2.5))
ax.matshow(confmat, cmap=plt.cm.Blues, alpha=0.3)
for i in range(confmat.shape[0]):
  for j in range(confmat.shape[1]):
    ax.text(x=j,
            y=i,
            s=confmat[i, j],
            va='center',
            ha='center')
plt.xlabel('predicted label')
plt.ylabel('true label')
plt.show()
# Assuming that class 1 (malignant) is the positive class in this example, our
# model correctly classified 71 of the samples that belong to class 0 (true
# negatives) and 40 samples that belong to class 1 (true positives),
# respectively. However, our model also incorrectly misclassified 1 sample from
# class 0 as class 1 (false positive), and it predicted that 2 samples are
# benign although it is a malignant tumor (false negatives).


